//____Prueba NAVE_2023_
//SDL/C
//SETA43

#include <stdio.h>
#include <stdlib.h>

#include <time.h>

#include "define.h"

#ifdef SDL2
    #include "SDL2/SDL.h"
    #include "SDL2/SDL_ttf.h"
    #include "SDL2/SDL_image.h"
    #include "SDL2/SDL_mixer.h"
#else
    #include <SDL/SDL.h>
    #include "SDL/SDL_ttf.h"
    #include "SDL/SDL_image.h"
    #include "SDL/SDL_mixer.h"
#endif

#include "main.h"
#include "agrafi.h"

#include "mode16x.h"


char titulo[]="NAVE SDL2_2023_ xsetaseta@gmail.com\n";

int inkeyM(void);
int waitQuit(void);
void printc(int x, int y, char* temp);
void printn(int x, int y, long temp);
void impri(int x, int y, char c);
char *inputc(int x, int y);
void imprixxx(int xi, int yi, int xo, int yo, int w, int h);

void Inicializar(void);
void cuentaAtras(void);

void printNave(void);
void printDisparos(void);
void disparoGo(void);

void printEnemigos(void);
void moverEnemigos(void);

char colisionNave(void);
char colisionDis(void);

void animarMuerte(void);
void animarInicio(void);

void Repaint(void);
void printPanta(void);



unsigned int tiempoX;
#define RETARDO 50
int Puntos,navesVuelo,vidas,nivel;

Mix_Chunk *acomer4 = NULL;
Mix_Chunk *adisparo = NULL;
Mix_Chunk *amuerte = NULL;
Mix_Chunk *avolver = NULL;
Mix_Chunk *aover = NULL;
Mix_Chunk *ainit = NULL;
Mix_Chunk *abeep = NULL;

#define ENEMIGO1  24,324
#define ENEMIGO2	48,324
#define ENEMIGO3	72,324
#define ENEMIGO_EX1  24,300
#define ENEMIGO_EX2  48,300

#define NAVE_EX_1 96,348
#define NAVE_EX_2 144,348

#define DISPARO1  32,372

#define INCREMENTO 5



//====================JUEGO=======================
int naveX=100,naveY=100;
int naveIX,naveIY;
bool naveE;

#define DISPARO_VELO 16
#define NUM_DISPAROS  5
struct DISPA {
    int x;
    int y;
    bool s;
    int velo;
};
struct DISPA disparo[NUM_DISPAROS];


//----------------------------
#define ENEMI_VELO 16
#define NUM_ENEMI  14
struct ENEMI {
    int x;
    int y;
    int ix;
    int iy;
    int s;
    int t;
    int velo;
};
struct ENEMI enemigo[NUM_ENEMI];



//========================


#include "puntos.h"

int main (int argc, char *argv[])
{
    int z;
    int quit = 0;
    int SimbolKey;
    bool fullScreen = false;

    if (init(640,480) == 0 ) return 1;
    //Fondo,graficos,fuentes
    if (load_files((char*)"nave0.jpg", (char*)"nave.png", (char*)"setam.ttf") == 0 ) return 2;

    acomer4=  Mix_LoadWAV( "acomer4.wav" );
    adisparo= Mix_LoadWAV( "adisparo.wav" );
    amuerte = Mix_LoadWAV( "amuerte.wav" );
    avolver = Mix_LoadWAV( "avolver.wav" );
    aover = Mix_LoadWAV( "aover.wav" );
    ainit = Mix_LoadWAV( "ainit.wav" );
    abeep = Mix_LoadWAV( "abeep.wav" );

    if(Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, 1024) == -1) //Initialisation de l'API Mixer
    {
        printf("%s", Mix_GetError());
    }
    else
    {
        printf("OK MIX\n");
    }

    indexG(0,0,16,16);
    SDL_ShowCursor(SDL_DISABLE);
    load_puntos();
    puntuar(0);
    if(1==waitQuit()) goto FinPrograma;  //Salir
Inicio:
    vidas=3;
    Puntos=0;
    nivel=0;
    Inicializar();
    refresco();
    cuentaAtras();

    //__________JUEGO___________________________
    while (quit==0)
    {
        SDL_Delay(10);

        while ( SDL_PollEvent( &event ) )
        {
            switch (event.type)
            {
            case  SDL_KEYUP:
                SimbolKey = event.key.keysym.sym;
                break;
            case  SDL_KEYDOWN:
                SimbolKey = event.key.keysym.sym;
                switch (SimbolKey)
                {
                case  SDLK_F1:
                    fullScreen = !fullScreen;
                    screenFull(fullScreen);
                    Repaint();
                    break;
                case  SDLK_F4:
                    Inicializar();
                    Repaint();
                    break;
                case  SDLK_ESCAPE:
                    quit = 1;
                    break;
                case SDLK_UP :
                    naveIY=-INCREMENTO;
                    break;
                case SDLK_DOWN :
                    naveIY=INCREMENTO;
                    break;
                case SDLK_LEFT :
                    naveIX=-INCREMENTO;
                    break;
                case SDLK_RIGHT :
                    naveIX=INCREMENTO;
                    break;
                case SDLK_s :
                    naveIX=naveIY=0;
                    break;
                case SDLK_d :
                    disparoGo();
                    break;
                }

                break;
            case  SDL_QUIT:
                quit = 1;
                break;
            }
        }


        if(SDL_GetTicks()>tiempoX)
        {
            tiempoX=SDL_GetTicks()+RETARDO;

            if(naveY<0 && naveIY<0) naveIY=0;
            if(naveY>460 && naveIY>0) naveIY=0;
            if(naveX<0 && naveIX<0) naveIX=0;
            if(naveX>570 && naveIX>0) naveIX=0;

            naveX+=naveIX;
            naveY+=naveIY;

            colisionDis();
            navesVuelo=0;
            for(z=0; z<NUM_ENEMI; z++)  if(enemigo[z].s!=0) navesVuelo++;
            if(navesVuelo<1)
            {
                nivel++;
                Inicializar();
                setcolor(255, 10, 0);
                Mix_PlayChannel( -1, avolver, 0 );
                SDL_Delay(1500);
                cuentaAtras();
            }
            if(0!=colisionNave())
            {
                animarMuerte();
                vidas--;
                SDL_Delay(300);
                if(vidas<1)
                {
                    Mix_PlayChannel( -1, aover, 0 );
                    SDL_Delay(1500);
                    puntuar(Puntos);
                    if(1==waitQuit()) goto FinPrograma;  //Salir
                    goto Inicio;
                }
                Mix_PlayChannel( -1, avolver, 0 );
                SDL_Delay(1500);
                Inicializar();
                cuentaAtras();
                setcolor(255, 10, 0);

            }
            moverEnemigos();

            printPanta();
        }
    }

FinPrograma:
    //Cerrar todo el SDL
    clean_up();
    printf("Fin_%s\n",titulo);
    SDL_Delay(400);
    return 0;
}


//____________________FIN____________
void cuentaAtras(void)
{
    int z;
    static char temp[10];
    for(z=5; z>0; z--)
    {
        printPanta();
        sprintf(temp, "--%d--", z);
        printcG(290,240,temp);
        refresco();
        Mix_PlayChannel( -1, abeep, 0 );
        SDL_Delay(1000);
    }
}



void Repaint(void)
{
    printPanta();
}

void printPanta(void)
{
 static char temp[50];
    //cls(0,0,0);
    static SDL_Rect clip[ 1 ];
    clip[ 0 ].x = 0;
    clip[ 0 ].y = 0;
    clip[ 0 ].w = SCREEN_WIDTH;
    clip[ 0 ].h = SCREEN_HEIGHT;
    apply_surfaceB( 0, 0, background, screen, &clip[ 0 ] );

    printDisparos();
    printNave();
    printEnemigos();

    sprintf(temp, "PUNTOS=%d    VIDAS=%d    NIVEL=%d", Puntos,vidas,nivel);
    printcG(50,460,temp);

    refresco();
}


void Inicializar(void)
{
    int z,zz;

    naveX=10;
    naveY=220;
    naveIX=naveIY=0;

    for(z=0; z<NUM_DISPAROS; z++)	disparo[z].s=0;

    for(z=0; z<7; z++)
    {
        enemigo[z].s=1;
        enemigo[z].t=1;
        enemigo[z].velo=ENEMI_VELO;
        enemigo[z].x=590;
        enemigo[z].y=z*64+20;
        enemigo[z].ix=nivel+4+rand() % 10;
        enemigo[z].iy=rand() % 7;
    }
    zz=0;
    for(z=7; z<NUM_ENEMI; z++)
    {
        enemigo[z].s=1;
        enemigo[z].t=2;
        enemigo[z].velo=ENEMI_VELO;
        enemigo[z].x=510;
        enemigo[z].y=zz*64+20;
        enemigo[z].ix=nivel+4+rand() % 10;
        enemigo[z].iy=rand() % 7;
        zz++;
    }

    enemigo[7].t=3;
    enemigo[7].ix+=3;
    enemigo[NUM_ENEMI-1].t=3;
    enemigo[NUM_ENEMI-1].ix+=3;

}



void animarMuerte(void)
{
    int z;

    Mix_PlayChannel( -1, amuerte, 0 );
    for(z=1; z<20; z++)
    {
        imprixxx(NAVE_EX_1,naveX, naveY, 48,24);
        refresco();
        SDL_Delay(100);
        imprixxx(NAVE_EX_2,naveX, naveY, 48,24);
        refresco();
        SDL_Delay(100);
    }
    SDL_Delay(600);
}


void animarInicio(void)
{
}




char colisionDis(void)
{
    int z,dis;
    for(dis=0; dis<NUM_DISPAROS; dis++)
    {
        if(disparo[dis].s!=0)
        {
            for(z=0; z<NUM_ENEMI; z++)
            {
                if(enemigo[z].s==1)
                {
                    if(disparo[dis].y>=enemigo[z].y && disparo[dis].y<=(24+enemigo[z].y)
                            &&	disparo[dis].x>=enemigo[z].x && disparo[dis].x<=(24+enemigo[z].x) )
                    {
                        enemigo[z].s=9;
                        disparo[dis].s=0;
                        Puntos++;
                        Mix_PlayChannel( -1, acomer4, 0 );
                        //printf("DESTRUIDO DIS=%d ENE=%d\n",dis,z);
                    }
                }
            }
        }
    }

    return(0);
}

char colisionNave(void)
{
    int z;

    for(z=0; z<NUM_ENEMI; z++)
    {
        if(enemigo[z].s==1)
        {
            if( (enemigo[z].y+21)>=naveY && enemigo[z].y<=naveY+21
                    &&	enemigo[z].x+21>naveX && enemigo[z].x<=naveX+45 )
            {
                enemigo[z].s=9;
                return(1);
            }
        }
    }

    return(0);
}



void printNave(void)
{
    naveE = !naveE;
    if(naveE)
    {
        imprixxx(0,348,naveX,naveY,48,24);
    }
    else
    {
        imprixxx(48,348,naveX,naveY,48,24);
    }

}


void printDisparos(void)
{
    for(int z=0; z<NUM_DISPAROS; z++)
    {
        if(disparo[z].s==1)
        {
            disparo[z].x+=disparo[z].velo;
            if(disparo[z].x>640) disparo[z].s=0;
            imprixxx(DISPARO1,disparo[z].x,disparo[z].y,32,4);
        }
    }

}

void disparoGo(void)
{
    Mix_PlayChannel( -1, adisparo, 0 );
    for(int dis=0; dis<NUM_DISPAROS; dis++)
    {
        if(disparo[dis].s==0)
        {
            disparo[dis].x=naveX+32;
            disparo[dis].y=naveY+12;
            disparo[dis].s=1;
            disparo[dis].velo=DISPARO_VELO;
            break;
        }
    }
}



void printEnemigos(void)
{
    int z;
    for(z=0; z<NUM_ENEMI; z++)
    {
        if(enemigo[z].s!=0)
        {
            switch (enemigo[z].s)
            {
            case 1:
                switch (enemigo[z].t)
                {
                case 1:
                    imprixxx( ENEMIGO1,enemigo[z].x,enemigo[z].y,24,24);
                    break;
                case 2:
                    imprixxx( ENEMIGO2,enemigo[z].x,enemigo[z].y,24,24);
                    break;
                case 3:
                    imprixxx( ENEMIGO3,enemigo[z].x,enemigo[z].y,24,24);
                    break;
                }

                break;
            case 9:
                imprixxx( ENEMIGO_EX1,enemigo[z].x,enemigo[z].y,24,24);
                enemigo[z].s++;
                break;
            case 10:
                imprixxx( ENEMIGO_EX2,enemigo[z].x,enemigo[z].y,24,24);
                enemigo[z].s=0;
                break;
            }

        }
    }
}



void moverEnemigos(void)
{
    int z;
    for(z=0; z<NUM_ENEMI; z++)
    {
        if(enemigo[z].s!=0)
        {
            enemigo[z].x-=enemigo[z].ix;
            enemigo[z].y+=enemigo[z].iy;
            if(enemigo[z].t==3 && (enemigo[z].y>460 || enemigo[z].y<0)) enemigo[z].iy*=-1;
            if(enemigo[z].x<-50  || enemigo[z].y<-50 || enemigo[z].y>520 )
            {
                enemigo[z].x=700;
                enemigo[z].y=rand() % 480;
                enemigo[z].ix=4+rand() % 10;
                enemigo[z].iy=rand() % 5;
                if( (rand() % 2)==1) enemigo[z].iy*=-1;
            }


        }

    }
}





//___________Rutinas basicas___________________
int inkeyM()
{
    int tecla;
    SDL_Delay(100);
    while ( SDL_PollEvent( &event ) )
    {
        switch (event.type)
        {
        case  SDL_KEYUP:
            tecla = event.key.keysym.sym;
            if (tecla > 96 && tecla < 123) tecla -= 32;
            return (tecla);
            break;
        case  SDL_QUIT:
            return (27);
            break;
        }
    }
    return (0);
}


int waitQuit(void)
{
    int SimbolKey;
    while(0!=inkeyM()) {}
    while(1)
    {
        SimbolKey=inkeyM();
        if(SimbolKey==27) return(1);
        if(SimbolKey!=0) return(0);
    }
}
//__________________________________
void imprixxx(int xi, int yi, int xo, int yo, int w, int h)
{
    static SDL_Rect clip[ 1 ];
    clip[ 0 ].x = xi;
    clip[ 0 ].y = yi;
    clip[ 0 ].w = w;
    clip[ 0 ].h = h;
    apply_surfaceB( xo, yo, dots, screen, &clip[ 0 ] );
}

void printc(int x, int y, char* temp)
{
    static SDL_Surface *message;
    message = TTF_RenderText_Solid( font, temp, ColorDefault );
    apply_surface( x, y, message, screen );
    SDL_FreeSurface(message);
}

void printn(int x, int y, long temp)
{
    char VARI[20];
    sprintf(VARI, "%d", (int)temp);
    printc(x, y, VARI);
}

void impri(int x, int y, char c)
{
    char VARI[20];
    sprintf(VARI, "%c", c);
    printc(x, y, VARI);
}



/* -------------------------- LEE CADENA DEL TECLADO ----*/

char *inputc(int x, int y)
{

    int zz, n;
    static char VARI[20];

    setcolor(0, 100, 0);
    bar(x, y, x + 100, y + 20);
    setcolor(255, 255, 255);
    refresco();
    for(zz=0; zz<10; zz++) inkeyM();

    n = 0;
    zz = 0;
    while (zz != 10)
    {
        zz = inkeyM();
        if (zz == 13 || zz == 27) goto fin;
        if (zz != 0)
        {
            setcolor(0, 100, 0);
            bar(x, y, x + 100, y + 20);
            setcolor(255, 255, 255);
            if (zz == 8)
            {
                n--;
                if (n < 0)n = 0;
                VARI[n] = 0;
            }
            else
            {
                VARI[n] = zz;
                VARI[n + 1] = 0;
                if (n < 6)n++;
            }
            printc(x, y, VARI);
            //        printf("%s\n",VARI);
            refresco();
        }
    }
fin:
    VARI[n] = 0;
    return (VARI);
}

